.include "c:\Gerhard\SteuerungWP\M8def.inc"
.include "c:\Gerhard\SteuerungWP\DefReg.inc"
.include "c:\Gerhard\SteuerungWP\DefRAM.inc"
.include "c:\Gerhard\SteuerungWP\DefKon.inc"



.CSEG
.org 0x000
		rjmp ProgStart
.org 0x004
		rjmp TC2OV 				;1/2 s Takt fr Blinken,Uhr,...
.org 0x008
		rjmp TC1OV           ;Wait fr 1-Wire Bus
.org 0x009
		rjmp TC0OV				;8,192 ms Takt 		
.org 0x00B		
		rjmp USARTRXC		
.org 0x00D		
		rjmp USARTTXC
.org 0x00E		
		rjmp ADCCC
.org 0x00F		
		rjmp EERDR
	
ProgStart:
		
		ldi temp1, low(STACKTOP)
      out SPL, temp1
		ldi temp1, high(STACKTOP)
      out SPH, temp1



		ldi ByteZa,0
		ldi BusTeilnZa,1
		clr ZaMStNr
		
				
	   rcall InitPort
	   rcall EEPROMDatLaden
		rcall InitRAM
		

		cbi PortD,PinPCSE		;PC SendEnable auf empfangen stellen
		cbi PortD,PinSE			;Eigenen SendEnable auf empfangen stellen
		
		
		rcall InitTimer1
		sei
		rcall Init1WireBus
				
		rcall InitLCD
		rcall InitADC
		rcall InitTimer0			
		rcall InitTimer2
		;rcall InitEEPROM
		rcall InitSleep
		
		

		

		
Warten:	
		
		rjmp Warten



;**************************************************************************************************************
.include "c:\Gerhard\SteuerungWP\InitRout.asm"
.include "c:\Gerhard\SteuerungWP\IntRout.asm"
.include "c:\Gerhard\SteuerungWP\SubRout.asm"
.include "c:\Gerhard\SteuerungWP\LCDRout.asm"
.include "c:\Gerhard\SteuerungWP\Konvert.asm"
.include "c:\Gerhard\SteuerungWP\Bedien.asm"
.include "c:\Gerhard\SteuerungWP\MEinst.asm"
.include "c:\Gerhard\SteuerungWP\MAnz.asm"
.include "c:\Gerhard\SteuerungWP\DS18B20.asm"



AnzByteTra:								;Anzahl Bytes zum Senden nach Index BusTeilnZa
.db 0,6,1,1

SSDatenTra1:							;Daten senden an PC
.dw SSTemp1,SSTemp2,SSTemp3,SSTemp4,SSDruck1,SSDruck2
	
SSDatenRec1:							;Daten empfangen vom PC
.db 0,0

SSDatenTra2:							;Daten senden an Hinten
.db SSNull,0

SSDatenRec2:							;Daten empfangen von Hinten
.db 0,0

SSDatenTra3:							;Daten senden an Vorne
.db SSNull,0

SSDatenRec3:							;Daten empfangen von Vorne
.db 0,0

ModusBW:
.db "  AUS",0
.db " AUTO",0
.db "DAUER",0

ModusHZ:
.db "  AUS",0
.db " AUTO",0
.db "DAUER",0
.db "ESTR.",0

AnzSSMode:
;.db Temp,Zeit,Geld,BW,HZ,Druck,Code
.db 1,2,1,1,1,1,2,0

AddCursorIndex:
;.db TempI0,TempI1,TempI2,TempI3,Zeit0-3,Geld0-3,ModeBW0-3,ModeHZ0-3,Druck,Code,
.db 0,0,10,1,10,1,10,1,0,100,10,1,0,0,0,1,0,0,0,1,0,0,10,1,10,1,10,1

TextZeile1:
.db "               hh:mm"

.equ EPUhrzeit = 15

Leerzeile:
.db "                    "


Ebene0:
.db " Allgemein          "				,0,2,0,0
.db " Brauchwasser       "				,0,2,2,1
.db " Heizung            "				,0,2,5,2

Ebene1:
.db " Uhr                "				,0,1,0,0
.db " Tarife             "				,0,1,1,1
.db " Betriebsarten      "				,2,4,5,2
.db " Freigabezeit       "				,2,4,6,3
.db " Solltemperatur     "				,2,4,8,4
.db " Betriebsarten      "				,5,6,9,5
.db " Estrichtermostat   "				,5,6,10,6


;.db "    Displaytext     ",EbeneMin,EbeneMax,EbeneEinsp,SSModus,SS0,SS1,SSEP,CI0,CI1,CI2,CI3,(HNibble:AnzCI LNibble:Zuord CI-SS),SS0Min,SS0Max,SS1Min,SS1Max
Ebene2:
.db " Uhrzeit       hh:mm"				,0,0,0,1,low(SSUhrzeitH),high(SSUhrzeitH),low(SSUhrzeitM),high(SSUhrzeitM),15,16,18,19,0b01000011,0,23,0,59,0
.db " Tag           C/kWh"				,1,4,0,2,low(SSTagCKWH),high(SSTagCKWH),low(SSNull),high(SSNull),10,11,12,13,0b00111000,0,100,0,0,1
.db " Nacht         C/kWh"				,1,4,0,2,low(SSNachtCKWh),high(SSNachtCKWh),low(SSNull),high(SSNull),10,11,12,13,0b00111000,0,100,0,0,2
.db " Tagbeginn     hh:mm"				,1,4,0,1,low(SSTagBH),high(SSTagBH),low(SSTagBM),high(SSTagBM),15,16,18,19,0b01000011,0,23,0,59,3
.db " Tagende       hh:mm"				,1,4,0,1,low(SSTagEH),high(SSTagEH),low(SSTagEM),high(SSTagEM),15,16,18,19,0b01000011,0,23,0,59,4
.db " BWWP               "				,5,5,0,3,low(SSModusBW),high(SSModusBW),low(SSNull),high(SSNull),19,19,19,19,0b00011110,0,2,0,0,5
.db " Beginn        hh:mm"				,6,7,0,1,low(SSBWWPBeginnH),high(SSBWWPBeginnH),low(SSBBWPBeginnM),high(SSBBWPBeginnM),15,16,18,19,0b01000011,0,23,0,59,6
.db " Ende          hh:mm"				,6,7,0,1,low(SSBWWPEndeH),high(SSBWWPEndeH),low(SSBWWPEndeM),high(SSBWWPEndeM),15,16,18,19,0b01000011,0,23,0,59,7
.db " Sollwert        ",0xDF,"C "	,8,8,0,0,low(SSBWSollw),high(SSBWSollw),low(SSNull),high(SSNull),15,15,15,16,0b00101100,0,80,0,0,8
.db " Heizung            "				,9,9,0,4,low(SSModusHZ),high(SSModusHZ),low(SSNull),high(SSNull),19,19,19,19,0b00011110,0,3,0,0,9
.db " Solltemp.       ",0xDF,"C "	,10,16,0,0,low(SSHZSollw),high(SSHZSollw),low(SSNull),high(SSNull),15,15,15,16,0b00101100,0,60,0,0,10
.db " Beginn1       hh:mm" 			,10,16,0,1,low(SSHZB1H),high(SSHZB1H),low(SSHZB1M),high(SSHZB1M),15,16,18,19,0b01000011,0,23,0,59,11
.db " Ende1         hh:mm" 			,10,16,0,1,low(SSHZE1H),high(SSHZE1H),low(SSHZE1M),high(SSHZE1M),15,16,18,19,0b01000011,0,23,0,59,12
.db " Beginn2       hh:mm"  	   	,10,16,0,1,low(SSHZB2H),high(SSHZB2H),low(SSHZB2M),high(SSHZB2M),15,16,18,19,0b01000011,0,23,0,59,13
.db " Ende2         hh:mm"   	   	,10,16,0,1,low(SSHZE2H),high(SSHZE2H),low(SSHZE2M),high(SSHZE2M),15,16,18,19,0b01000011,0,23,0,59,14
.db " Beginn3       hh:mm"   	   	,10,16,0,1,low(SSHZB3H),high(SSHZB3H),low(SSHZB3M),high(SSHZB3M),15,16,18,19,0b01000011,0,23,0,59,15
.db " Ende3         hh:mm"   		   ,10,16,0,1,low(SSHZE3H),high(SSHZE3H),low(SSHZE3M),high(SSHZE3M),15,16,18,19,0b01000011,0,23,0,59,16



Parameter:
.db " Code       xxxx    "				,0,6,0,6,low(SSCodeH),high(SSCodeH),low(SSCodeL),high(SSCodeL),12,13,14,15,0b01000011,0,99,0,99,0
.db " Anlaufverz.  xx Min"				,0,6,0,2,low(SSAnlaufVerz),high(SSAnlaufVerz),low(SSNull),high(SSNull),12,13,14,15,0b00101100,0,60,0,0,1
.db " Taktschutz   xx Min"				,0,6,0,2,low(SSTaktschutz),high(SSTaktschutz),low(SSNull),high(SSNull),12,13,14,15,0b00101100,0,60,0,0,2
.db " Grenztemp.VL    ",0xDF,"C "	,0,6,0,0,low(SSGrenztempVL),high(SSGrenztempVL),low(SSNull),high(SSNull),14,14,14,15,0b00101100,20,60,0,0,3
.db " Um.Kompr2   xxx Min"				,0,6,0,2,low(SSUmKompr2),high(SSUmKompr2),low(SSNull),high(SSNull),12,13,14,15,0b00111000,5,240,0,0,4
.db " Um.Magnetv. xxx Sec"				,0,6,0,2,low(SSUmMagnetV),high(SSUmMagnetV),low(SSNull),high(SSNull),12,13,14,15,0b00111000,1,120,0,0,5
.db " Frosts.WQA      ",0xDF,"C "	,0,6,0,0,low(SSFrostWQA),high(SSFrostWQA),low(SSNull),high(SSNull),14,14,14,15,0b00101100,-5,15,0,0,6





.equ MAnzAnzTexte = 10
;.db "  Displaytext     ",Modus,SS,EP,
Anzeigen:
.db " Temp1:          ",0xDF,"C ",0,low(SSTemp1),high(SSTemp1),14
.db " Temp2:          ",0xDF,"C ",0,low(SSTemp2),high(SSTemp2),14
.db " Temp3:          ",0xDF,"C ",0,low(SSTemp3),high(SSTemp3),14
.db " Temp4:          ",0xDF,"C ",0,low(SSTemp4),high(SSTemp4),14
.db " Temp5:          ",0xDF,"C ",0,low(SSTemp5),high(SSTemp5),14
.db " Temp6:          ",0xDF,"C ",0,low(SSTemp6),high(SSTemp6),14
.db " Temp7:          ",0xDF,"C ",0,low(SSTemp7),high(SSTemp7),14
.db " Temp8:          ",0xDF,"C ",0,low(SSTemp8),high(SSTemp8),14
.db " Sauggasdr.      bar",5,low(SSDruck1),high(SSDruck1),14
.db " Heissgasdr.     bar",5,low(SSDruck2),high(SSDruck2),14




.ESEG
.org 0x0150
.db 0,0,0,30,20,6,0,20,0,0,0,0,23,59,60,0
.db 20,0,0,6,0,9,0,12,0,15,0,18,0,0

.org 0x01A0
.db 0,0,0,0,25,10,3,0






























































































